--[[ ArenaLive Core Functions: Import and Export Lua Table Handler
File Created by: Vadrak
Code Created by: Shishei
Creation Date: 17.04.2015
Last Update: "
This function takes lua code and executes it in an isolated environment,
the environment is then returned and variables set in the code via
varname = value can be addressed outside via emptyenv.varname or 
[returnvalue].varname.
]]--

-- Create Handler:
local ImportExport = ArenaLive:ConstructHandler("ImportExport");

function ImportExport:TableToLuaData(t)
	if ( type(t) ~= "table" ) then
		ArenaLive:Message(L["%s: Usage %s"], "error", "ImportExport:TableToLuaData()", "ImportExport:TableToLuaData(table)");
	end
	
	local output = "\n{\n";
	local i = 0;

	for key, value in pairs(t) do
		if ( i > 0 ) then
			output = output .. ",\n";
		end

		if ( type(key) == "string" ) then
			output = output .. "[\"" .. key .. "\"] = ";
		else
             output = output .. "[" .. key .. "] = ";
		end

		if ( type(value) == "string" ) then
			output = output .. "\"" .. ImportExport:Escape(value) .."\"";
		elseif ( type(value) == "table" ) then
			output = output .. self:TableToLuaData(value);
		else
			output = output .. value;
		end

		i = i + 1;
	end
	
	output = output .. "\n}\n";

	return output;
end

function ImportExport:LuaDataToTable(text)
	local func = assert(loadstring(text));
	--local smallenv = { format=format, tostring=tostring, getglobal=getglobal}
	local emptyenv = {};
	setfenv(func, emptyenv);
	func();

	return emptyenv;
end

function ImportExport:Escape(text)

	text = string.gsub(text, [[\]], [[\\]] );
	
	return text;
end