--[[ ArenaLive Spectator Functions: Spectator Role Tracker
Created by: Vadrak
Creation Date: 22.03.2015
Last Update: "
]]--

-- Addon Name and localisation table:
local addonName, L = ...;

--[[
**************************************************
******* GENERAL HANDLER SET UP STARTS HERE *******
**************************************************
]]--
local RoleIcon = ArenaLive:ConstructHandler("SpectatorRoleIcon", true);
RoleIcon:RegisterEvent("AL_SPEC_PLAYER_SPECIALIZATION_UPDATE");

function RoleIcon:Update(unitFrame)
	local unit = unitFrame.unit;
	local roleIcon = unitFrame[self.name];
	if ( not unit ) then
		self:Reset(unitFrame);
		return;
	end

	local role = ArenaLiveSpectator.UnitCache:GetUnitRole(unit);
	if ( role == "HEALER" ) then
		roleIcon:SetTexture("Interface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES");
		roleIcon:SetTexCoord(GetTexCoordsForRoleSmallCircle(role));
		roleIcon:Show();
	else
		self:Reset(unitFrame);
	end
end

function RoleIcon:Reset(unitFrame)
	local roleIcon = unitFrame[self.name];
	roleIcon:Hide();
end

function RoleIcon:OnEvent(event, ...)
	local unit = ...;
	if ( ArenaLive:IsUnitInUnitFrameCache(unit) ) then
		for id in ArenaLive:GetAffectedUnitFramesByUnit(unit) do
			local unitFrame = ArenaLive:GetUnitFrameByID(id);
			if ( unitFrame[self.name] ) then
				RoleIcon:Update(unitFrame);
			end
		end
	end
end